; -*- Scheme -*-

; This file contains the definition of the button widget
(module sx-button
        mzscheme

(require (lib "class.ss") 
         (lib "mred.ss" "mred")
)

(provide sx-button-new
         sx-button?
         sx-button-label-set!
         sx-button-vert-margin-set!  
         sx-button-vert-margin-get
         sx-button-horiz-margin-set! 
         sx-button-horiz-margin-get
         sx-button-enable-set!
         sx-button-min-width-set! 
         sx-button-min-height-set!
         sx-image-button-new
         sx-image-button-image-get
         sx-image-button-image-set!
)


(define (sx-button-new parent label callback)
  (new button% 
       (label label)
       (parent parent)
       (callback callback)
  )
)

(define (sx-button? widget)
  (is-a? widget button%)
)

(define (sx-button-label-set! button label)
  (send button set-label label)
)

(define (sx-button-vert-margin-set! button margin)
  (send button vert-margin margin)
)

(define (sx-button-vert-margin-get button)
  (send button vert-margin)
)

(define (sx-button-horiz-margin-set! button margin)
  (send button horiz-margin margin)
)

(define (sx-button-horiz-margin-get button)
  (send button horiz-margin)
)

(define (sx-button-enable-set! button enable?)
  (send button enable enable?)
)

(define (sx-button-min-width-set! button width)
  (send button min-width width)
)

(define (sx-button-min-height-set! button height)
  (send button min-height height)
)

; --------------------------------------------------------------------

(define (sx-image-button-new parent bitmap callback)
  (new button% 
       (parent parent)
       (label bitmap)
       (callback callback)
  )
)

; returns a bitmap object
(define (sx-image-button-image-get button)
  (send button get-label)
)

(define (sx-image-button-image-set! button image)
  (send button set-label image)
)


) ; end of module


