; -*- Scheme -*-

; This file contains the definition of the check box widget
(module sx-check-box
        mzscheme

(require (lib "class.ss") 
         (lib "mred.ss" "mred")
)

(provide sx-check-box-new
         sx-check-box?
         sx-check-box-label-set!
         sx-check-box-min-width-set!
         sx-check-box-min-height-set!
         sx-check-box-value-get
         sx-check-box-value-set!
)

; init-value can be #t or #f whether it should be marked or not
(define (sx-check-box-new parent label init-value func)
  (new check-box%
       (parent parent)
       (label  label)
       (value  init-value)
       (callback func)
  )
)

(define (sx-check-box? check-box)
  (is-a? check-box check-box%)
)

(define (sx-check-box-label-set! check-box label)
  (send check-box set-label label)
)

(define (sx-check-box-min-width-set! check-box width)
  (send check-box min-width width)
)

(define (sx-check-box-min-height-set! check-box height)
  (send check-box min-height height)
)


(define (sx-check-box-value-get check-box)
  (send check-box get-value)
)

(define (sx-check-box-value-set! check-box value)
  (send check-box set-value value)
)

) ; end of module



