; -*- Scheme -*-

; This file contains the definition of the choice widget
(module sx-choice
        mzscheme

(require (lib "class.ss") 
         (lib "mred.ss" "mred")
)

(provide sx-choice-new
         sx-choice?
         sx-choice-clear
         sx-choice-append
         sx-choice-get-number
         sx-choice-set-selection
         sx-choice-get-selection
         sx-choice-label-set!
         sx-choice-min-width-set!
         sx-choice-min-height-set!
         sx-choice-select-by-index-set!
         sx-choice-select-by-string-set!
         sx-choice-selected-index-get
         sx-choice-selected-string-get
)


; choices: is a list of selectable strings
; style:   a list of style
(define (sx-choice-new parent label choices func)
  (new choice% (parent   parent)
               (label    label)
               (choices  choices)
               (callback func)
  )
)


(define (sx-choice? lb)
  (is-a? lb choice%)
)

(define (sx-choice-clear lb)
  (send lb clear)
)


(define (sx-choice-append lb item)
  (send lb append item)
)

(define (sx-choice-get-number lb)
  (send lb get-number)
)

(define (sx-choice-set-selection lb value)
  (send lb set-selection value)
)

(define (sx-choice-get-selection lb)
  (send lb get-selection)
)

(define (sx-choice-label-set! lb label)
  (send lb set-label label)
)

(define (sx-choice-min-width-set! lb width)
  (send lb min-width width)
)


(define (sx-choice-min-height-set! lb height)
  (send lb min-height height)
)


(define (sx-choice-select-by-index-set! lb index)
  (send lb set-selection index)
)


(define (sx-choice-select-by-string-set! lb string)
  (send lb set-string-selection string)
)


; returns a list of indices of the selected items
(define (sx-choice-selected-index-get lb)
  (send lb get-selection)
)


(define (sx-choice-selected-string-get lb n)
  (send lb get-string n)
)


) ; end of module



