; -*- Scheme -*-

; This file contains the definition of different box widgets
(module sx-container
        mzscheme

(require (lib "class.ss") 
         (lib "mred.ss" "mred")
         (lib "framework.ss" "framework")
)

(provide sx-row-new 
         sx-row-stretch-y-set! sx-row-stretch-y-get
         sx-row-stretch-x-set! sx-row-stretch-x-get
         sx-row-min-width-set! sx-row-min-height-set!
         sx-row-alignment-set!
         sx-row-border-set!
         ;;;
         sx-boxed-column-new
         sx-boxed-column?
         sx-boxed-column-stretch-y-set! sx-boxed-column-stretch-y-get
         sx-boxed-column-stretch-x-set! sx-boxed-column-stretch-x-get
         sx-boxed-column-min-width-set! sx-boxed-column-min-height-set!
         sx-boxed-column-label-set!
         sx-boxed-column-alignment-set!
         sx-boxed-column-border-set!
         ;;;
         sx-column-new 
         sx-column-stretch-y-set! sx-column-stretch-y-get
         sx-column-stretch-x-set! sx-column-stretch-x-get
         sx-column-min-width-set! sx-column-min-height-set!
         sx-column-alignment-set!
         sx-column-border-set!
         ;;;
         sx-dragable-column-new sx-dragable-column-percentage
         sx-dragable-column-stretch-y-set! sx-dragable-column-stretch-y-get
         sx-dragable-column-stretch-x-set! sx-dragable-column-stretch-x-get
         sx-dragable-column-min-width-set! sx-dragable-column-min-height-set!
         sx-dragable-column-alignment-set!
         sx-dragable-column-border-set!
         ;;;
         sx-tab-panel-new
         sx-tab-panel?
         sx-tab-panel-get-number
         sx-tab-panel-set-selection
         sx-tab-panel-get-selection
         sx-tab-panel-append
         sx-tab-new
         sx-tab?
)

; --------------------------------------------------------------------

(define (sx-row-new parent)
  (new horizontal-panel% (parent parent))
)

(define (sx-row-stretch-y-set! row enable?)
  (send row stretchable-height enable?)
)

(define (sx-row-stretch-y-get row)
  (send row stretchable-height)
)

(define (sx-row-stretch-x-set! row enable?)
  (send row stretchable-width enable?)
)

(define (sx-row-stretch-x-get row)
  (send row stretchable-width)
)

(define (sx-row-min-width-set! row width)
  (send row min-width width)
)

(define (sx-row-min-height-set! row height)
  (send row min-height height)
)

(define (sx-row-alignment-set! row horiz-align vert-align)
  (send row set-alignment horiz-align vert-align)
)

(define (sx-row-border-set! row margin)
  (send row border margin)
)

; --------------------------------------------------------------------

(define (sx-boxed-column-new parent label)
  (new group-box-panel% (parent parent) (label label))
)
  
(define (sx-boxed-column? widget)
  (is-a? widget group-box-panel%)
)

(define (sx-boxed-column-stretch-y-set! boxed-column enable?)
  (send boxed-column stretchable-height enable?)
)

(define (sx-boxed-column-stretch-y-get boxed-column enable?)
  (send boxed-column stretchable-height)
)

(define (sx-boxed-column-stretch-x-set! boxed-column enable?)
  (send boxed-column stretchable-width enable?)
)

(define (sx-boxed-column-stretch-x-get boxed-column enable?)
  (send boxed-column stretchable-width)
)

(define (sx-boxed-column-min-width-set! boxed-column width)
  (send boxed-column min-width width)
)

(define (sx-boxed-column-min-height-set! boxed-column height)
  (send boxed-column min-height height)
)

(define (sx-boxed-column-label-set! boxed-column label)
  (send boxed-column set-label label)
)

(define (sx-boxed-column-alignment-set! boxed-column horiz-align vert-align)
  (send boxed-column set-alignment horiz-align vert-align)
)

(define (sx-boxed-column-border-set! boxed-column margin)
  (send boxed-column border margin)
)

; --------------------------------------------------------------------

(define (sx-column-new parent)
  (new vertical-panel% (parent parent))
)

(define (sx-column-stretch-y-set! column enable?)
  (send column stretchable-height enable?)
)

(define (sx-column-stretch-y-get column enable?)
  (send column stretchable-height)
)

(define (sx-column-stretch-x-set! column enable?)
  (send column stretchable-width enable?)
)

(define (sx-column-stretch-x-get column enable?)
  (send column stretchable-width)
)

(define (sx-column-min-width-set! column width)
  (send column min-width width)
)

(define (sx-column-min-height-set! column height)
  (send column min-height height)
)

(define (sx-column-alignment-set! column horiz-align vert-align)
  (send column set-alignment horiz-align vert-align)
)

(define (sx-column-border-set! column margin)
  (send column border margin)
)

; --------------------------------------------------------------------

; dragable, resizeable vertical container
(define (sx-dragable-column-new parent)
  (new panel:vertical-dragable% (parent parent))
)

(define (sx-dragable-column-percentage column percent)
  (send column set-percentages percent)
)

(define (sx-dragable-column-stretch-y-set! dragable-column enable?)
  (send dragable-column stretchable-height enable?)
)

(define (sx-dragable-column-stretch-y-get dragable-column enable?)
  (send dragable-column stretchable-height)
)

(define (sx-dragable-column-stretch-x-set! dragable-column enable?)
  (send dragable-column stretchable-width enable?)
)

(define (sx-dragable-column-stretch-x-get dragable-column enable?)
  (send dragable-column stretchable-width)
)

(define (sx-dragable-column-min-width-set! dragable-column width)
  (send dragable-column min-width width)
)

(define (sx-dragable-column-min-height-set! dragable-column height)
  (send dragable-column min-height height)
)

(define (sx-dragable-column-alignment-set! dragable-column 
                                           horiz-align 
                                           vert-align)
  (send dragable-column set-alignment horiz-align vert-align)
)

(define (sx-dragable-column-border-set! dragable-column margin)
  (send dragable-column border margin)
)

; --------------------------------------------------------------------

; a tabbed panel
  
(define sx-tab-panel%
  (class panel:single%
    (define container #f)
    (define panels '())
    
    (define/public (container-set! widget)
      (set! container widget)
    )
    
    (define/public (container-get)
      container
    )
    
    (define/public (get-panels) 
      panels
    )
    
    (define/public (clear-panels) 
      (set! panels '())
    )
    
    (define/public (append-panel item)
      (set! panels (append panels (list item)))
    )
    
    (super-new)
  )
)


(define sx-tab%
  (class vertical-panel%
    (super-new)
  )
)


(define (sx-tab-panel-new parent)
  (letrec
    ( (update-panel
        (lambda (p e)
          (send swapping-panel 
                active-child
                (list-ref (send swapping-panel get-panels) (send tab-panel get-selection)))
        )
      )
      (tab-panel (new tab-panel%
                      (parent parent)
                      (callback update-panel)
                      (choices '())))
      (swapping-panel (new sx-tab-panel%
                           (parent tab-panel)
                           (alignment '(left center))
                           (stretchable-width #t)))
    )
    (send swapping-panel container-set! tab-panel)
    swapping-panel
  )
)


(define (sx-tab-panel? widget)
  (is-a? widget sx-tab-panel%)
)

  
(define (sx-tab-panel-get-number widget)
  (let ((container (send widget container-get)))
    (send container get-number)
  )
)


(define (sx-tab-panel-set-selection widget value)
  (let ((container (send widget container-get)))
    (send container set-selection value)
    (send widget 
          active-child
          (list-ref (send widget get-panels) value))
  )
)


(define (sx-tab-panel-get-selection widget)
  (let ((container (send widget container-get)))
    (send container get-selection)
  )
)

; this adds a tab to a tab-panel
(define (sx-tab-panel-append tab-panel name widget)
  (let ((container (send tab-panel container-get)))
    (send container append name)
    (send tab-panel append-panel widget)
  )
)
  
(define (sx-tab-new parent)
  (new sx-tab% (parent parent))
)


(define (sx-tab? widget)
  (is-a? widget sx-tab%)
)

  

; this is the old interface
(define (sx-tab-panel-old-new parent choices)
  (letrec
    ( (update-panel
        (lambda (p e)
          (send swapping-panel 
                active-child
                (list-ref panels (send tab-panel get-selection)))
        )
      )
      (tab-panel (new tab-panel%
                      (parent parent)
                      (callback update-panel)
                      (choices choices)))
      (swapping-panel (new panel:single%
                           (parent tab-panel)
                           (alignment '(left center))
                           (stretchable-width #t)))
      (panels (map (lambda (x) (sx-column-new swapping-panel)) choices))
    )
    panels
  )
)


) ; end of module
