; -*- Scheme -*-

; This file contains the definition of a dialog widget
(module sx-dialog
        mzscheme

(require (lib "class.ss") 
         (lib "mred.ss" "mred")
)

(provide sx-dialog-new
         sx-dialog?
         sx-dialog-show
         sx-dialog-hide
         sx-dialog-center
         sx-dialog-is-shown?
         sx-dialog-border-set!
)

; always resizeable dialog window is created
(define (sx-dialog-new parent label width height)
  (new dialog%
       (parent parent)
       (label label)
       (width width)
       (height height)
       (style '(resize-border))
  )
)


(define (sx-dialog? widget)
  (is-a? widget dialog%)
)


(define (sx-dialog-show window)
  (send window show #t)
)


(define (sx-dialog-hide window)
  (send window show #f)
)


(define (sx-dialog-center window)
  (send window center)
)


(define (sx-dialog-is-shown? window)
  (send window is-shown?)
)


(define (sx-dialog-border-set! dialog border)
  (send dialog border border)
)


) ; end of module


