; -*- Scheme -*-

;/****m*
;* NAME
;*   sx-hash
;* DESCRIPTION
;*   This module contains the implementation of hashing. The implemented hash 
;*   tables are dynamically expandable !!!
;******/

(module sx-hash
        mzscheme

(provide sx-hash-make sx-hash? sx-hash-length sx-hash-null?
         sx-hash-put! sx-hash-get sx-hash-remove!
         sx-hash-map sx-hash-for-each
)

(define (sx-hash-make)
  (make-hash-table 'equal)
)

(define (sx-hash? table)
  (hash-table? table)
)

(define (sx-hash-length table)
  (hash-table-count table)
)

(define (sx-hash-null? table)
  (= (hash-table-count table) 0)
)

(define (sx-hash-put! table key value)
  (hash-table-put! table key value)
)

(define (sx-hash-get table key)
  (hash-table-get table key (lambda () #f))
)

(define (sx-hash-remove! table key)
  (hash-table-remove! table key)
)

(define (sx-hash-map proc table)
  (hash-table-map table proc)
)

(define (sx-hash-for-each proc table)
  (hash-table-for-each table proc)
)


) ; end of module


