; -*- Scheme -*-

; This file contains the definition of the list box widget
(module sx-list-box
        mzscheme

(require (lib "class.ss") 
         (lib "mred.ss" "mred")
)

(provide sx-list-box-new
         sx-list-box?
         sx-list-box-clear
         sx-list-box-append
         sx-list-box-get-number
         sx-list-box-set-selection
         sx-list-box-get-selection
         sx-list-box-event-type
         sx-list-box-min-width-set!
         sx-list-box-min-height-set!
         sx-list-box-stretch-x-set!
         sx-list-box-stretch-y-set!
         sx-list-box-select-by-index-set!
         sx-list-box-select-by-string-set!
         sx-list-box-selected-index-get
         sx-list-box-selected-string-get
)


; choices: is a list of selectable strings
; style:   a list of style
(define (sx-list-box-new parent label choices style func)
  (new list-box% (parent   parent)
                 (label    label)
                 (choices  choices)
                 (style    style)
                 (callback func)
  )
)


(define (sx-list-box? lb)
  (is-a? lb list-box%)
)


(define (sx-list-box-clear lb)
  (send lb clear)
)


(define (sx-list-box-append lb item)
  (send lb append item)
)


(define (sx-list-box-get-number lb)
  (send lb get-number)
)


(define (sx-list-box-set-selection lb value)
  (send lb select value (not (send lb is-selected? value)))
)


(define (sx-list-box-get-selection lb)
  (send lb get-selection)
)


(define (sx-list-box-event-type event)
  (send event get-event-type)
)


(define (sx-list-box-min-width-set! lb width)
  (send lb min-width width)
)


(define (sx-list-box-min-height-set! lb height)
  (send lb min-height height)
)

(define (sx-list-box-stretch-x-set! lb enable?)
  (send lb stretchable-width enable?)
)

(define (sx-list-box-stretch-y-set! lb enable?)
  (send lb stretchable-height enable?)
)

(define (sx-list-box-select-by-index-set! lb index)
  (send lb set-selection index)
)


(define (sx-list-box-select-by-string-set! lb string)
  (send lb set-string-selection string)
)


; returns a list of indices of the selected items
(define (sx-list-box-selected-index-get lb)
  (send lb get-selections)
)


(define (sx-list-box-selected-string-get lb n)
  (send lb get-string n)
)


) ; end of module



